           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |               August 2004                 |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM10_Seq_Sys = DM09_Seq_def:

(*****************************************************************

         1. proves lemma for Seq =F Sys
         2.
         3. 
         4. 

 *****************************************************************)

(*** Seq_Back0_WR1 ***)

lemma Seq_Back0_WR1:
  "LET SysDef IN (Rewrite (SeqDef (Seq_Back0_WR1 n)) By Seq_to_Sys) =F
   LET SysDef IN Seq_to_Sys (Seq_Back0_WR1 n)"
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
done

lemmas SEQ_rules = Seq_Back0_WR1

(*** Seq_WR0_Back1 ***)

lemma Seq_WR0_Back1:
  "LET SysDef IN (Rewrite (SeqDef (Seq_WR0_Back1 n)) By Seq_to_Sys) =F
   LET SysDef IN Seq_to_Sys (Seq_WR0_Back1 n)"
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (rule csp_Timeout_cong)
apply (tactic {* csp_simp_tac 1 *})

apply (rule csp_Timeout_cong)
apply (simp)
apply (case_tac "~ ODD (n div 2)")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
done

lemmas SEQ_rules = SEQ_rules Seq_WR0_Back1

(*** Seq_Back0_EAT1 ***)

lemma Seq_Back0_EAT1:
  "LET SysDef IN (Rewrite (SeqDef (Seq_Back0_EAT1 n)) By Seq_to_Sys) =F
   LET SysDef IN Seq_to_Sys (Seq_Back0_EAT1 n)"
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
done

lemmas SEQ_rules = SEQ_rules Seq_Back0_EAT1

(*** Seq_EAT0_Back1 ***)

lemma Seq_EAT0_Back1:
  "LET SysDef IN (Rewrite (SeqDef (Seq_EAT0_Back1 n)) By Seq_to_Sys) =F
   LET SysDef IN Seq_to_Sys (Seq_EAT0_Back1 n)"
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
done

lemmas SEQ_rules = SEQ_rules Seq_EAT0_Back1

end
